format PE64 GUI 6.0
entry start
include 'win64a.inc'
section '.code' code readable executable
;----------------------------------------------------------
proc start
;local  wc:WNDCLASSEX
local msg:MSG


       ; sub     rsp,8           ; Make stack dqword aligned
        invoke GetModuleHandle,0
        mov [wc.hInstance],rax
        mov [wc.cbSize],sizeof.WNDCLASSEX
        mov [wc.style],CS_HREDRAW or CS_VREDRAW
        mov [wc.lpfnWndProc],WindowProc
        mov [wc.cbClsExtra],0
        invoke LoadIcon,0,IDI_APPLICATION
        mov [wc.hIcon],rax
        mov [wc.hIconSm],rax
        invoke LoadCursor,0,IDC_ARROW
        mov [wc.hCursor],rax
        mov [wc.hbrBackground],COLOR_WINDOW+1
        mov [wc.lpszMenuName],NULL
        mov [wc.lpszClassName],szTitle
        lea ecx,[wc]
        invoke RegisterClassEx

        ;  GDI+
        mov     [gdiplusSInput.GdiplusVersion],1
        mov     [gdiplusSInput.DebugEventCallback],0
        mov     [gdiplusSInput.SuppressBackgroundThread],0
        mov     [gdiplusSInput.SuppressExternalCodecs],0
        invoke  GdiplusStartup,gdiplusToken,gdiplusSInput,0

        invoke CreateWindowEx,0,szTitle,szTitle,WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
        CW_USEDEFAULT,CW_USEDEFAULT,500,500,NULL,NULL,[wc.hInstance],NULL
        lea edi,[msg]

msg_loop:
        invoke  GetMessage,edi,NULL,0,0
        or      rax,rax
        je      exit
        invoke  TranslateMessage,edi
        invoke  DispatchMessage,edi
        jmp     msg_loop
exit:
        invoke  GdiplusShutdown
        invoke ExitProcess,[msg.wParam]
endp
;-----------------------------------------------------------
proc WindowProc uses rbx rsi rdi, hwnd,wmsg,wparam,lparam
;---         ---
local ps:PAINTSTRUCT
;----------------------------------
        mov     [hwnd],rcx
        frame
      ;  cmp     edx,WM_CREATE
      ;  je      .wmcreate
      ;  cmp     edx,WM_SIZE
      ;  je      .wmsize
        cmp     edx,WM_PAINT
        je      .wmpaint
      ;  cmp     edx,WM_KEYDOWN
      ;  je      .wmkeydown
      ;  cmp     edx,WM_SETFOCUS
      ;  je      .wmsetfocus
        cmp     edx,WM_DESTROY
        je      .wmdestroy
.defwndproc:
        invoke  DefWindowProc,rcx,rdx,r8,r9
        jmp     .finish
;---    ---
;.wmsize:
;   invoke GetClientRect,[hwnd],addr rc
;   invoke MoveWindow,[hedit],[rc.left],[rc.top],[rc.right],[rc.bottom],TRUE
;   mov eax,0
;   jmp     .finish
;.wmsetfocus:
;   invoke SetFocus,[hedit]
;   mov eax,0
;   jmp .finish
.wmpaint:
    ; lea     rdx,[ps]
     invoke  BeginPaint,[hwnd],addr ps


       stdcall onPaintText,[ps.hdc]


     invoke  EndPaint,[hwnd],addr ps
jmp     .finish
;.wmkeydown:
;jmp     .finish
;.wmcreate:
     ;invoke GetClientRect,[hwnd],addr rc
     ;invoke MessageBox,0,nofnc2,title,MB_OK


    ;jmp .finish

.failed:
    mov eax,-1
    invoke MessageBox,0,nofnc,title,MB_OK
    jmp .finish
;-------------------------------------
.wmdestroy:
        ;invoke  ReleaseDC,[hwnd],[hdc]
        invoke  PostQuitMessage,0
        xor     eax,eax
.finish:
        endf
        ret
endp
;------------------------------------------------------------
proc onPaintText hdc
local  pGraphics:QWORD
local  pSolidBrush:QWORD
local  pFont:QWORD
local  UnicodeText[100]:BYTE
local  UnicodeFont[100]:BYTE
local  pFontFamily:QWORD
locals
 szText      db 'hello word',0

 szFontName  db 'Times New Roman',0

endl
        ;?  ;   PointF      pointF(10.0f, 20.0f);
    ;    finit
    ;    fild x
    ;    fstp layoutRect.x
    ;    fild y
    ;    fstp layoutRect.y
        ;?


        invoke  GdipCreateFromHDC,[hdc],addr pGraphics ; Graphics    graphics(hdc)
        invoke  GdipCreateSolidFill,0FF000000h,addr pSolidBrush ; SolidBrush  brush(Color(255, 0, 0, 255));
        invoke  MultiByteToWideChar,0,0,addr szText,-1,addr UnicodeText,100 ;   
        invoke  MultiByteToWideChar,0,0,addr szFontName,-1,addr UnicodeFont,100 ;    
        invoke  GdipCreateFontFamilyFromName,addr UnicodeFont, 0, addr pFontFamily;FontFamily  fontFamily(L"Times New Roman");

       ; movd xmm1,emSize
;   Font        font(&fontFamily, 24, FontStyleRegular, UnitPixel);
        invoke GdipCreateFont,pFontFamily,16,1,2,addr pFont



;   graphics.DrawString(L"Hello World!", -1, &font, pointF, &brush);
    invoke GdipDrawString,pGraphics, addr UnicodeText, 24, pFont, addr layoutRect , 0, pSolidBrush

     ;   
     invoke  GdipDeleteBrush,[pSolidBrush]
     invoke  GdipDeleteFontFamily,[pFontFamily]
     invoke  GdipDeleteGraphics,[pGraphics]
     ret
endp
;#####################   data  ############################
section '.data' data readable writeable

szTitle    db 'GDI+  ',0
title      db ' ',0
nofnc      db '',0
nofnc2     db '  ',0
rc  RECT
wc  WNDCLASSEX
;-----------------------------------
;     GDI+
struct GdiplusStartupInput
    GdiplusVersion           dd ?
    DebugEventCallback       dd ?
    SuppressBackgroundThread dd ?
    SuppressExternalCodecs   dd ?
ends
gdiplusToken    dd ?
gdiplusSInput   GdiplusStartupInput


;szText     db 'hello word!',0
;szFontName db 'Consolas',0


struct PointF
  x dd  ?
  y dd  ?
ends

pFont     dd ?
layoutRect  PointF

emSize      dd 30
;##################### end data ############################
section '.idata' import data readable writeable
  library kernel,'KERNEL32.DLL',\
          user,'USER32.DLL',\
          gdiplus,'gdiplus.dll',\
          gdi,'GDI32.DLL'
  import  kernel,\
          ExitProcess,'ExitProcess',\
          GetModuleHandle,'GetModuleHandleA',\
          MultiByteToWideChar,'MultiByteToWideChar'

  import  user,\
          PostQuitMessage,'PostQuitMessage',\
          LoadIcon,'LoadIconA',\
          LoadCursor,'LoadCursorA',\
          RegisterClassEx,'RegisterClassExA',\
          CreateWindowEx,'CreateWindowExA',\
          DefWindowProc,'DefWindowProcA',\
          GetMessage,'GetMessageA',\
          TranslateMessage,'TranslateMessage',\
          DispatchMessage,'DispatchMessageA',\
          GetClientRect,'GetClientRect',\
          MessageBox,'MessageBoxA',\
          MoveWindow,'MoveWindow',\
          SendMessage,'SendMessageA',\
          SetFocus,'SetFocus',\
          BeginPaint,'BeginPaint',\
          EndPaint,'EndPaint'


   import gdi,\
          CreateFont,'CreateFontA'

 import gdiplus,\
        GdiplusStartup,'GdiplusStartup',\
        GdiplusShutdown,'GdiplusShutdown',\
        GdipCreateBitmapFromStream,'GdipCreateBitmapFromStream',\
        GdipCreateFromHWND,'GdipCreateFromHWND',\
        GdipDrawImageRectI,'GdipDrawImageRectI',\
        GdipGetImageDimension,'GdipGetImageDimension',\
        GdipDeleteGraphics,'GdipDeleteGraphics',\
        GdipDisposeImage,'GdipDisposeImage',\
        GdipGetImageWidth,'GdipGetImageWidth',\
        GdipGetImageHeight,'GdipGetImageHeight',\
        GdipCreateBitmapFromFile,'GdipCreateBitmapFromFile',\
        GdipCreateHBITMAPFromBitmap,'GdipCreateHBITMAPFromBitmap',\
        GdipCreateFromHDC, 'GdipCreateFromHDC',\
        GdipCreatePen1, 'GdipCreatePen1',\
        GdipDeletePen, 'GdipDeletePen',\
        GdipDrawLineI, 'GdipDrawLineI',\
        GdipSetSmoothingMode, 'GdipSetSmoothingMode',\
        GdipCreateSolidFill,'GdipCreateSolidFill',\
        GdipCreateFontFamilyFromName,'GdipCreateFontFamilyFromName',\
        GdipCreateFont,'GdipCreateFont',\
        GdipDrawString,'GdipDrawString',\
        GdipDeleteBrush,'GdipDeleteBrush',\
        GdipDeleteFontFamily,'GdipDeleteFontFamily'



